/*
 * Copyright 2017 Red Hat, Inc. and/or its affiliates.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

package org.kie.workbench.common.forms.editor.client.editor.changes.displayers.conflicts;

import javax.enterprise.context.Dependent;
import javax.inject.Inject;

import org.jboss.errai.common.client.api.IsElement;
import org.jboss.errai.common.client.dom.HTMLElement;
import org.kie.soup.commons.validation.PortablePreconditions;
import org.kie.workbench.common.forms.editor.client.editor.changes.conflicts.element.ConflictElement;

@Dependent
public class ConflictsDisplayer implements IsElement,
                                           ConflictsDisplayerView.Presenter {

    private ConflictsDisplayerView view;

    @Inject
    public ConflictsDisplayer(ConflictsDisplayerView view) {
        this.view = view;

        view.init(this);
    }

    public void clear() {
        view.clear();
    }

    @Override
    public HTMLElement getElement() {
        return view.getElement();
    }

    public void showConflict(ConflictElement conflictElement) {
        PortablePreconditions.checkNotNull("conflictElement",
                                           conflictElement);

        view.showConflict(conflictElement);
    }
}
