/*
 * Copyright 2017 Red Hat, Inc. and/or its affiliates.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

package org.kie.workbench.common.stunner.core.rule.context;

import java.util.Set;

import org.kie.workbench.common.stunner.core.rule.RuleEvaluationContext;
import org.kie.workbench.common.stunner.core.rule.handler.impl.ConnectionEvaluationHandler;
import org.kie.workbench.common.stunner.core.rule.impl.CanContain;

/**
 * This rule evaluation context provides the runtime information
 * that allows the evaluation for parent-child related operations.
 * @See {@link CanContain}
 * @See {@link ConnectionEvaluationHandler}
 */
public interface ContainmentContext extends RuleEvaluationContext {

    /**
     * The role that provides the containment restriction.
     */
    Set<String> getParentRoles();

    /**
     * The set of roles that are allowed to
     * be used as children.
     */
    Set<String> getCandidateRoles();
}
